// evaluation of Exp

public class EvalVisitor implements ExpVisitor<Result> {

    private final Table table;

    EvalVisitor (Table table) {
        this.table = table;
    }

    public Result visit (IdExp e) {
        return new Result (table.lookup (e.id), table);
    }

    public Result visit (NumExp e) {
        return new Result (e.num, table);
    }

    public Result visit (OpExp e) {
        Result l = e.left.accept (this);
        Result r = e.right.accept (new EvalVisitor (l.table));
        return new Result (Op.calc (l.value, e.op, r.value), r.table);
    }

    public Result visit (EseqExp e) {
        Table t = e.stm.accept (new RunVisitor (table));
        return e.exp.accept (new EvalVisitor (t));
    }
}