
public class PrintVisitor implements ExpListVisitor<Table> {

    private final Table table;

    PrintVisitor (Table table) {
        this.table = table;
    }

    public Table visit (LastExpList e) {
        Result r = e.head.accept (new EvalVisitor (table));
        System.out.print (r.value + "\n");
        return r.table;
    }

    public Table visit (PairExpList e) {
        Result r = e.head.accept (new EvalVisitor (table));
        System.out.print (r.value + " ");
        return e.tail.accept (new PrintVisitor (r.table));
    }

}
