// evaluation of Exp

class RunVisitor implements StmVisitor<Table> {

    final private Table table;

    RunVisitor (Table table) {
        this.table = table;
    }

    public Table visit (CompoundStm s) {
        Table t1 = s.stm1.accept (this);
        return s.stm2.accept (new RunVisitor (t1));
    }

    public Table visit (AssignStm s) {
        Result r = s.exp.accept (new EvalVisitor (table));
        return new UpdateTable (s.id, r.value, r.table);
    }

    public Table visit (PrintStm s) {
        return s.exps.accept (new PrintVisitor (table));
    }
}